<?php

defined('BASEPATH') OR exit('No direct script access allowed');
/* Copyright (C) Hawks Solutions  - All Rights Reserved 
 * 
 * Unauthorized copying of this file, via any medium is strictly prohibited
 * 
 * Proprietary and confidential 
 * 
 * Written by Developer <info@hawkssolutions.com>, November 2017  */

class Welcome extends FrontendController {

    function __construct() {
        parent::__construct();
        $this->load->model('Common');
        $this->load->model('ContentType');
        $this->load->model('Content');
        $this->load->model('Upload');
    }

    public function index() {
        $this->load->view('home/layouts/header');
        $this->load->view('home/index');
        $this->load->view('home/layouts/footer');
    }

    public function ajax() {
        $data = $this->input->post();
        $action = $data["action"];
        if (!empty($action)) {
            switch ($action) {
                case "loadContents":
                    return $this->loadContents();
                    break;
            }
        }
    }

    /*
     * fn to load contents of the page.
     */

    private function loadContents() {
        $contentTypes = $this->ContentType->get();
        foreach ($contentTypes as $cType) {
            //taking content(s)
            $content = $this->Common->getFullContent($cType->id);
            $image = $this->Common->getImages($cType->id);
            if ($content) {
                $contentArray[$cType->content_type]['content'] = $content;
                if ($image) {
                    $contentArray[$cType->content_type]['image'] = $image;
                } else {
                    $contentArray[$cType->content_type]['image'] = [];
                }
            } else {
                $contentArray[$cType->content_type]['content'] = [];
                if ($image) {
                    $contentArray[$cType->content_type]['image'] = $image;
                } else {
                    $contentArray[$cType->content_type]['image'] = [];
                }
            }
        }
        $data = array(
            'contentArray' => $contentArray,
        );
        echo json_encode($data);
    }

}
