<?php
defined('BASEPATH') OR exit('No direct script access allowed');

/* Copyright (C) Hawks Solutions  - All Rights Reserved 
 * 
 * Unauthorized copying of this file, via any medium is strictly prohibited
 * 
 * Proprietary and confidential 
 * 
 * Written by Anuraj <anurajpr2266@gmail.com>, November 2017  
 */

class Dashboard extends AdminController {

    public function __construct() {
        parent::__construct();
        $this->load->library('encryption');
        $this->load->model('ContentType');
        $this->load->model('Content');
        $this->load->model('Categories');
        $this->load->model('Types');
        $this->load->model('Products');
        // $this->load->model('Designs');
        // $this->load->model('ProductBenefits');
        // $this->load->model('Works');
        $this->load->model('Upload');
    }
    public function index() {
        $data['title'] = (TITLE != "") ? TITLE : "Admin Panel | HST";
        $data['author'] = (AUTHOR != "") ? AUTHOR : "Hawks Solutions";
        $data['description'] = (DESCRIPTION != "") ? DESCRIPTION : "A web portal";
        $uploads=$this->Upload->get();
        $contenttypes=$this->ContentType->get();
        $logs=$this->Common->getallfromlogs();
//        foreach ($logs as $log){
//            
//        }
//        die;
        $data['logsdetails']=$logs;
        $data['totalcontents']=count($contenttypes);
        $data['totalimages']=count($uploads);
        $this->load->view('admin/layouts/header', $data);
        $this->load->view('admin/dashboard', $data);
        $this->load->view('admin/layouts/footer');
    }

    /*
     * function action , controlles all uri actions 
     * 
     * @params string
     * 
     * @return mixed 
     */

    public function action($action = null) {
        switch ($action) {
//            case 'imagetype' :
//                $data['title'] = (TITLE != "") ? TITLE : "Achakkottil Family";
//                $data['author'] = (AUTHOR != "") ? AUTHOR : "Hawks Solutions";
//                $data['description'] = (DESCRIPTION != "") ? DESCRIPTION : "A Family portal";
//                $this->load->view('admin/layouts/header', $data);
//                $this->load->view('admin/imagetype', $data);
//                $this->load->view('admin/layouts/footer');
//                break;
            case 'content':
                $data['contentTypes'] = $this->Common->getAllContentTypes('`haveContent`=1');
                $this->load->view('admin/layouts/header');
                $this->load->view('admin/content', $data);
                $this->load->view('admin/layouts/footer');
                break;
         case 'Portfolio':
                $data['contentTypes'] = $this->Common->getAllContentTypes('`haveContent`=1');
                $this->load->view('admin/layouts/header');
                $this->load->view('admin/portfolio', $data);
                $this->load->view('admin/layouts/footer');
                break;
            case 'contenttype' :
                $this->load->view('admin/layouts/header');
                $this->load->view('admin/contenttype');
                $this->load->view('admin/layouts/footer');
                break;
            case 'changepassword':
                $this->load->view('admin/layouts/header');
                $this->load->view('admin/changepassword');
                $this->load->view('admin/layouts/footer');
                break;
            case 'category':
                $this->load->view('admin/layouts/header');
                $this->load->view('admin/category');
                $this->load->view('admin/layouts/footer');
                break;
            case 'type':
                $this->load->view('admin/layouts/header');
                $this->load->view('admin/type');
                $this->load->view('admin/layouts/footer');
                break;
            case 'product':
                $data['types']=$this->Types->getAllTypes();
                $data['categories']=$this->Categories->getAllCategories();
                $data['packets']=json_encode(array(
                    '100 ML','500 ML','1 Ltr','4 Ltr','10 Ltr','20 Ltr','1 Kg','5 Kg','15 Kg','25 Kg'));
                $this->load->view('admin/layouts/header');
                $this->load->view('admin/product',$data);
                $this->load->view('admin/layouts/footer');
                break;
            case 'designs':
                $this->load->view('admin/layouts/header');
                $this->load->view('admin/design');
                $this->load->view('admin/layouts/footer');
                break;
            case 'productBenefit':
                $data['products']=json_encode($this->Products->getAll());
                $data['benefits']=json_encode($this->Benefits->getAll());
                $this->load->view('admin/layouts/header');
                $this->load->view('admin/productbenefits',$data);
                $this->load->view('admin/layouts/footer');
                break;
            case 'productFinishes':
                $data['products']=json_encode($this->Products->getAll());
                $data['finishes']=FINISHES;
                // var_dump($data['finishes']);exit;
                $this->load->view('admin/layouts/header');
                $this->load->view('admin/productfinishes',$data);
                $this->load->view('admin/layouts/footer');
                break;
            case 'works':
                $data['works']=json_encode($this->Works->getAll());
                $this->load->view('admin/layouts/header');
                $this->load->view('admin/work',$data);
                $this->load->view('admin/layouts/footer');
                break;
            default :
                break;
        }
    }

    public function ajax() {
        $data = $this->input->post();
        $action = $data["action"];
        if (!empty($action)) {
            switch ($action) {
                case "savecontenttype":
                    return $this->savecontenttype($data);
                    break;
                case "getContentTypes":
                    return $this->getContentTypes();
                    break;
                case "deleteContenttype":
                    $typeId = $data['typeId'];
                    return $this->deleteContenttype($typeId);
                case "getContentByType":
                    echo ($this->Common->getContentByType($data['contenttype']));
                    break;
                case "saveContent":
                    return $this->saveContent($data);
                    break;
                case "deleteContent":
                    $contentId = $data['contentId'];
                    return $this->deleteContent($contentId);
                    break;
                case "changepassword":
                    return $this->changepassword($data);
                    break;
                case "savecategory":
                    return $this->savecategory($data);
                    break;
                case "getCategories":
                    return $this->getCategories();
                    break;
                case "getCategoryById":
                    $id=$data['id'];
                    return $this->getCategoryById($id);
                    break;
                case "deleteCategory":
                    $id=$data['id'];
                    return $this->deleteCategory($id);
                    break;
                case "getTypes":
                    return $this->getTypes();
                    break;
                case "saveType":
                    return $this->saveType($data);
                    break;
                case "deleteType":
                    $id=$data['id'];
                    return $this->deleteType($id);
                    break; 
                case "getProducts":
                    return $this->getProducts();
                    break;
                case "saveProduct":
                    return $this->saveProduct($data);
                    break;
                case "getProductsById":
                    $id=$data['productid'];
                    return $this->getProductsById($id);
                    break;
                case "deleteProduct":
                    $id=$data['id'];
                    return $this->deleteProduct($id);
                    break;
                case "getDesigns":
                    return $this->getDesigns();
                    break;
                case "saveDesign":
                    return $this->saveDesign($data);
                    break;
                case "getDesignById":
                    $id=$data['benefitid'];
                    return $this->getDesignById($id);
                    break;
                case "deleteDesign":
                    $id=$data['id'];
                    return $this->deleteDesign($id);
                    break;
                case "saveProductBenefit":
                     return $this->saveProductBenefit($data);
                    break;
                case "getProductBenefit":
                    $id=$data['id'];
                    return $this->getBenefitsByProduct($id);
                    break;
                case "getProductFinishes":
                    $id=$data['id'];
                    return $this->getProductFinishes($id);
                    break;
                case "saveProductFinishes":
                    return $this->saveProductFinishes($data);
                    break;
                case "getWorks":
                    return $this->getWorks();
                    break;
                case "saveWork":
                    return $this->saveWork($data);
                    break;
                case "getWorkById":
                    $id=$data['workid'];
                    return $this->getWorkById($id);
                    break;
                case "deleteWork":
                    $id=$data['id'];
                    return $this->deleteWork($id);
                    break;
            }
        }
    }

    public function savecontenttype($data = null) {
        if (!empty($data)) {
            if (isset($data['haveimage'])) {
                $haveimage = 1;
            } else {
                $haveimage = 0;
            }if (isset($data['multipleimage'])) {
                $multipleimage = 1;
            } else {
                $multipleimage = 0;
            }if (isset($data['havemultiplecontent'])) {
                $havemultiplecontent = 1;
            } else {
                $havemultiplecontent = 0;
            }if (isset($data['havecontent'])) {
                $havecontent = 1;
            } else {
                $havecontent = 0;
            }
            $contents = array(
                'content_type' => $data['contenttype'],
                'haveImg' => $haveimage,
                'width' => $data['width'],
                'height' => $data['Height'],
                'haveMultpleImg' => $multipleimage,
                'haveMultipleContent' => $havemultiplecontent,
                'haveContent' => $havecontent,
            );
            $id = $this->ContentType->save($contents);

            $contentdata = $this->ContentType->get($id);
            $returndata = array(
                'success' => true,
                'contenttype' => $contentdata->content_type,
                'haveImg' => $contentdata->haveImg,
                'width' => $contentdata->width,
                'height' => $contentdata->height,
                'haveMultpleImg' => $contentdata->haveMultpleImg,
                'haveMultipleContent' => $contentdata->haveMultipleContent,
                'haveContent' => $contentdata->haveContent,
            );
        } else {
            $returndata = array(
                'success' => false,
            );
        }
        echo json_encode($returndata);
    }


    private function getContentTypes() {
        $contentTypes = $this->ContentType->get();
        if (!empty($contentTypes)) {
            $data = array(
                'success' => true,
                'contentTypes' => $contentTypes,
            );
            echo json_encode($data);
        }
    }
   
    /*
     * fn to delete content type.
     * param is content type id. 
     */

    private function deleteContenttype($typeId) {
        if (!empty($typeId)) {
            if ($this->ContentType->delete($typeId)) {
                $data = array(
                    'success' => true,
                );
                echo json_encode($data);
            }
        }
    }

    /*
     * fn to save the content.
     */

    private function saveContent($data) {
        if (!empty($data)) {
            $ctype=$this->ContentType->get($data['contentTypeId']);
            if ($data['contentId'] == 0) {
                //saving
                $content = array(
                    'content' => $data['content'],
                    'name'=>$data['name'],
                    'content2'=>$data['content2'],
                    'content_type_id' => $data['contentTypeId'],
                    'end_date' => $data['enddate'],
                );
                // var_dump($content);
                $contentId=$this->Content->save($content);
                
               
                    //for inserting table logs..
                    $userId=$this->session->userdata('siteData');
                    $logdata = array(
                        'username' => $userId[0]['username'],
                        'contentId' => $contentId,
                        'imgId'=>0,
                        'description'=>$userId[0]['username'].''.' added content',
                    );
                    $this->Common->insertLogs($logdata);
                    // logs table insertion ends here
                    
                    
                if ($contentId) {
                    $data = array(
                        'success' => true,
                        'update' => FALSE,
                        'content' => $data['content'],
                        'content2' => $data['content2'],
                        'content_type' => $ctype->content_type,
                        'created_date' => date('Y-m-d'),
                        'contentId' => $contentId,
                        'name'=>$data['name'],
                        'end_date'=>$data['enddate'],
                        'multipleCotent' => $ctype->haveMultipleContent,
                    );
                    // var_dump($data);exit;
                    echo json_encode($data);
                }
            } else {
                //updating 
                $content = array(
                    'content' => $data['content'],
                    'content2' => $data['content2'],
                    'name'=>$data['name'],
                    'content_type_id' => $data['contentTypeId'],
                    'end_date' => $data['enddate'],
                );
                if ($this->Content->save($content,$data['contentId'])) {
                    //    for inserting table logs..
                    $userId=$this->session->userdata('siteData');
                    $logdata = array(
                        'username' => $userId[0]['username'],
                        'contentId' => $data['contentId'],
                        'imgId'=>0,
                        'description'=>$userId[0]['username'].''.' edited content',
                    );
                    $this->Common->insertLogs($logdata);
                   // logs table insertion ends here
                    $data = array(
                        'success' => true,
                        'update' => true,
                        'content' => $data['content'],
                        'content2' => $data['content2'],
                        'name'=>$data['name'],
                        'content_type' => $ctype->content_type,
                        'created_date' => date('Y-m-d'),
                        'contentId' => $data['contentId'],
                        'end_date'=>$data['enddate'],
                        'multipleCotent' => $ctype->haveMultipleContent,
                    );
                    echo json_encode($data);
                }
            }
        }
    }
    
    /*
     * fn to delete the content.
     * param is content id.
     */
    private function deleteContent($contentId) {
        if (!empty($contentId)) {
            if ($this->Content->delete($contentId)) {
                $data = array(
                    'success' => true,
                );
                
                    //for inserting table logs..
                    $userId=$this->session->userdata('siteData');
                    $logdata = array(
                        'username' => $userId[0]['username'],
                        'contentId' => $contentId,
                        'imgId'=>0,
                        'description'=>$userId[0]['username'].''.' deleted content',
                    );
                    $this->Common->insertLogs($logdata);
                    // logs table insertion ends here
                    
                    
                echo json_encode($data);
            }
        }
    }
    
     /*
     * fn to change passwords.
     * param is old password and newpassword.
     */
    
    
     public function changepassword($data) {

        if (!empty($data['oldpassword']) && $data['newpassword']) {
            $oldpassword = sha1($data['oldpassword']);
            $confirmoldpaswrd = $this->Common->getOldpassword($oldpassword);
            if (!empty($confirmoldpaswrd)) {
                $userid = $confirmoldpaswrd[0]->id;
                $newdata = sha1($data['newpassword']);
                $save = $this->Common->savenewpassword($newdata, $userid);
                $succesdata = array(
                    'success' => true,
                );
            } else {
                $succesdata = array(
                    'success' => false,
                );
            }
            echo json_encode($succesdata);
        } else {
            $responsedata = array(
                'error' => true,
            );
            echo json_encode($responsedata);
        }
    }

// Function To handle Categories
/*
* To get all categories
* No param
*returns array with success bit and categories
*/
 private function getCategories()
    {
        $categories=$this->Categories->get();
        if(!empty($categories)){
            $data=array(
                 'success' => true,
                'categories'=>$categories
            );
            echo json_encode($data);
        }            
    }
/*
* To get one categories
* No param
*returns array with success bit and categories
*/
 private function getCategoryById($id)
    {
        $category=$this->Categories->get($id);
        if(!empty($category)){
            $data=array(
                 'success' => true,
                'category'=>$category
            );
            echo json_encode($data);
        }            
    }

/*
* Save Category
* Param category as array
*returns true or false
*/
    private function savecategory($data=null){
        if(!empty($data))
        {
            if(!empty($data['bgchangable']))
                $bgchangable=1;
            else
                $bgchangable=0;

            $category=array(
                'category'=>$data['category'],
                'bgchangable'=>$bgchangable
            );
            if(!empty($data['categoryId']))
                $id=$this->Categories->save($category,$data['categoryId']);
            else
                $id=$this->Categories->save($category);
            $returndata=array(
                'category'=>$data['category'],
                'success' => true,
            );

        }else{
            $returndata = array(
                'success' => false,
            );
        }
         echo json_encode($returndata);
    }
    /*
    * Delete Category
    * Param id 
    * returns true or false
    */
   private function deleteCategory($id){
    if (!empty($id)) {
            if ($this->Categories->delete($id)) {
                $data = array(
                    'success' => true,
                );
                echo json_encode($data);
            }
        }
   }
// Functions of categories ends

   // Functions to manage types
   /*
    * Get All types
    * No params
    * returns array of types with success bit
   */
   private function getTypes(){
    $types=$this->Types->get();
    if(!empty($types))
    {
        $data=array(
            'success'=>true,
            'types'=>$types
        );

    }else{
        $data=array(
            'success'=>false
        );

    }
    echo json_encode($data);

   }
   /*
   * Function save type
   * param type
   * returns true or false
   */
   private function saveType($data){
    if(!empty($data)){
        $type=array(
            'type'=>$data['type'],
        );
        if($this->Types->save($type))
        {
            $data=array(
                'success'=>true,
                'type'=>$type
            );
        }
    }else{
        $data=array(
            'success'=>false,
        );
    }
    echo json_encode($data);
   }
   /*
   * Delete type
   * param id
   * return bool
    */
   private function deleteType($id){
    if(!empty($id))
        if($this->Types->delete($id)>0)
        {
            $data=array(
                'success'=>true,
            );
            echo json_encode($data);
        }
   }
   // Functions to manage type ends

   // Functions to manage products
    /*
    * get all products
    * no params
    * returns array of prodcuts
    */
    private function getProducts(){
        $products=$this->Products->getAll();
        if(!empty($products))
        {
            $returndata=array(
                'success'=>true,
                'products'=>$products
            );
            echo json_encode($returndata);
        }
    }

   /*
   * save products
   * params name,type,category,desc as array
   * returns bool
   */
   private function saveProduct($data){
    if(!empty($data))
    {
        if(isset($data['featured'])){
            $featured=1;
        }else{
            $featured=0;
        }
        if(isset($data['direction'])){
            $direction=$data['direction'];
        }else{
           $direction="";
        }

        $product=array(
            'name'=>$data['productname'],
            'categoryId'=>$data['category'],
            'typeId'=>$data['type'],
            'description'=>$data['description'],
            'direction'=>$direction,
            'featured'=>$featured,
        );
        $id=isset($data['productId'])?$data['productId']:0;
        if(!empty($id)){
            $insert=$this->Products->save($product,$id);
            $packetdeleteArr=[];
            $ids=$this->Products->getpacketids($id);
            if(!empty($ids)){
            foreach ($ids as $id) {
                array_push($packetdeleteArr,$id->id);
            }
            $this->db->where_in('id',$packetdeleteArr);
            $this->db->delete('packets');
            }
        }
        else
            $insert=$this->Products->save($product);

        if($insert>0)
        {
            $packetArray=[];
            foreach ($data['availablePackets'] as $packet) {
                $arr=array(
                    'productId'=>$insert,
                    'packetSize'=>$packet,
                );
                array_push($packetArray,$arr);
            }
            $this->db->insert_batch('packets',$packetArray);
            $returndata=array(
                'success'=>true,
                'product'=>$product
            );
        }else{
            $returndata=array(
                'success'=>false,
            );
        }
        echo json_encode($returndata);
    }else{
       $returndata=array('success'=>false);
       echo json_encode($returndata);
   }
}
/*
* Get Products By Id for edit in modal
* params id
* return product info
*/
private function getProductsById($id){
    if(!empty($id)){
        $product=$this->Products->getProductById($id);
        $types=$this->Types->getForProduct();
        $categories=$this->Categories->getForProduct();
        $packets=$this->Products->getpacketsOfProduct($id,null);
        if(!empty($product)){
           
            $productInfo=array(
                'name'=>$product->name,
                'category'=>$product->categoryId,
                'type'=>$product->typeId,
                'description'=>$product->description,
            );
            $returndata=array(
                'success'=>true,
                'productInfo'=>json_encode($productInfo),
                'categories'=>$categories,
                'packets'=>$packets,
                'types'=>$types,
               
            );
            echo json_encode($returndata);
        }else{
       $returndata=array('success'=>false);
       echo json_encode($returndata);
   }
    }else{
       $returndata=array('success'=>false);
       echo json_encode($returndata);
   }

}
/*
    * Delete Product
    * param id
    * returns bool
   */
   private function deleteProduct($id){
    if(!empty($id))
        if($this->Products->delete($id)>0)
        {
            $data=array(
                'success'=>true,
            );
            echo json_encode($data);
        }
   }
   
   // Functions to manage products ends

   // Functions to manage Design
    /*
    * get all Design
    * no params
    * returns array of Design
    */
    private function getDesigns(){
        $designs=$this->Designs->getAllDesigns();
        if(!empty($designs))
        {
            $returndata=array(
                'success'=>true,
                'designs'=>$designs
            );
            echo json_encode($returndata);
        }
    }

   /*
   * save Designs
   * params Design,product,desc as array
   * returns bool
   */
   private function saveDesign($data){
    if(!empty($data))
    {
        $temp=explode('.', $data["image"]);
                $ext=end($temp);
                $imageName =time().'.'.$ext;
                
        $path="assets/images/uploads/workedDesign/";
        $design=array(
            'design'=>$data['design'],
            'description'=>$data['description'],
        );
        $id=isset($data['designId'])?$data['designId']:0;
        if(!empty($id)&&$id>0)
            $insert=$this->Designs->save($design,$id);
        else
            $insert=$this->Designs->save($design);
        if($insert>0&&$this->imageUpload($imageName,$ext,$path,$data['file']))
        {
            $returndata=array(
                'success'=>true,
                'design'=>$design
            );
        }else{
            $returndata=array(
                'success'=>false,
            );
        }
        echo json_encode($returndata);
    }else{
       $returndata=array('success'=>false);
       echo json_encode($returndata);
   }
}
   /*
   * save Product benefits
   * params benefit,productid
   * returns bool
   */
   private function saveProductBenefit($data){
    if(!empty($data))
    {
        $productbenefit=[];
        foreach ($data['productbenefits'] as $benefitid) {
            array_push($productbenefit,array(
            'benefitId'=>$benefitid,
            'productId'=>$data['product'],
        ));
        }
        $idArray=$this->ProductBenefits->getBenefitIds($data['product']);
        if(!empty($idArray)){
            $idToDelete=[];
            foreach ($idArray as $id) {
                array_push($idToDelete,$id->id);
            }
            $this->db->where_in('id', $idToDelete);
            $this->db->delete('productBenefits');
        }
            $insert=$this->db->insert_batch('productBenefits',$productbenefit);
        if($insert>0)
        {
            $returndata=array(
                'success'=>true,
            );
        }else{
            $returndata=array(
                'success'=>false,
            );
        }
        echo json_encode($returndata);
    }else{
       $returndata=array('success'=>false);
       echo json_encode($returndata);
   }
}
/*
* Get Design By Id for edit in modal
* params id
* return Design info
*/
private function getDesigntById($id){
    if(!empty($id)){
        $design=$this->Benefits->getDesignById($id);
        if(!empty($design)){
           
            $designInfo=array(
                'design'=>$design->design,
                'description'=>$design->description,
            );
            $returndata=array(
                'success'=>true,
                'designInfo'=>json_encode($designInfo),
            );
            echo json_encode($returndata);
        }
        else{
       $returndata=array('success'=>false);
       echo json_encode($returndata);
   }
    }else{
       $returndata=array('success'=>false);
       echo json_encode($returndata);
   }

}
/*
    * Delete Design
    * param id
    * returns bool
   */
   private function deleteDesign($id){
    if(!empty($id))
        if($this->Designs->delete($id)>0)
        {
            $data=array(
                'success'=>true,
            );
            echo json_encode($data);
        }
   }
   /*
    * Get Benefitsby Product
    * Param product Id
    * returns array of Benefits
   */
   private function getBenefitsByProduct($id){
    if(!empty($id)){
         $productbenefits=$this->ProductBenefits->getBenefitsByProduct($id);
         $benefits=$this->Benefits->getAll(); 
        if(!empty($productbenefits))
        {
            $returndata=array(
                'success'=>true,
                'productbenefits'=>$productbenefits
            );
        }else{
            $returndata=array(
                'success'=>true,
            );
        }

            echo json_encode($returndata);
    }
   }
   /*
    * Get ProductFinishes Product
    * Param product Id
    * returns array of Benefits
   */
   private function getProductFinishes($id){
    if(!empty($id)){
         $productfinishes=$this->Products->getProductFinishes($id);
         $finishes=FINISHES; 
        if(!empty($productfinishes))
        {
            $returndata=array(
                'success'=>true,
                'productfinishes'=>$productfinishes
            );
        }else{
            $returndata=array(
                'success'=>true,
            );
        }

            echo json_encode($returndata);
    }
   }

   /*
   * save Product benefits
   * params benefit,productid
   * returns bool
   */
   private function saveProductFinishes($data){
    if(!empty($data))
    {
        $productfinish=[];
        foreach ($data['finishes'] as $finish) {
            array_push($productfinish,array(
            'finish'=>$finish,
            'productId'=>$data['product'],
        ));
        }
        $idArray=$this->Products->getFinishIds($data['product']);
        if(!empty($idArray)){
            $idToDelete=[];
            foreach ($idArray as $id) {
                array_push($idToDelete,$id->id);
            }
            $this->db->where_in('id', $idToDelete);
            $this->db->delete('finishes');
        }
            $insert=$this->db->insert_batch('finishes',$productfinish);
        if($insert>0)
        {
            $returndata=array(
                'success'=>true,
            );
        }else{
            $returndata=array(
                'success'=>false,
            );
        }
        echo json_encode($returndata);
    }else{
       $returndata=array('success'=>false);
       echo json_encode($returndata);
   }
}
   // Functions to manage benefits ends
   // Functions to manage Works
    /*
    * get all Works
    * no params
    * returns array of works
    */
    private function getWorks(){
        $works=$this->Works->getAll();
        if(!empty($works))
        {
            $returndata=array(
                'success'=>true,
                'works'=>$works
            );
            echo json_encode($returndata);
        }
    }

   /*
   * save work
   * params title,desc as array
   * returns bool
   */
   private function saveWork($data){
    if(!empty($data))
    {
        $work=array(
            'title'=>$data['title'],
            'description'=>$data['description'],
        );
        $id=isset($data['workId'])?$data['workId']:0;
        if(!empty($id)&&$id>0)
            $insert=$this->Works->save($work,$id);
        else
            $insert=$this->Works->save($work);
        if($insert>0)
        {
            $returndata=array(
                'success'=>true,
                'work'=>$work
            );
        }else{
            $returndata=array(
                'success'=>false,
            );
        }
        echo json_encode($returndata);
    }else{
       $returndata=array('success'=>false);
       echo json_encode($returndata);
   }
}
/*
* Get Work By Id for edit in modal
* params id
* return work info
*/
private function getWorkById($id){
    if(!empty($id)){
        $work=$this->Works->getWorkById($id);
        if(!empty($work)){
           
            $workInfo=array(
                'title'=>$work->title,
                'description'=>$work->description,
            );
            $returndata=array(
                'success'=>true,
                'workInfo'=>json_encode($workInfo), 
            );
            echo json_encode($returndata);
        }
        else{
       $returndata=array('success'=>false);
       echo json_encode($returndata);
   }
    }else{
       $returndata=array('success'=>false);
       echo json_encode($returndata);
   }

}
/*
    * Delete Work
    * param id
    * returns bool
   */
   private function deleteWork($id){
    if(!empty($id))
        if($this->Works->delete($id)>0)
        {
            $data=array(
                'success'=>true,
            );
            echo json_encode($data);
        }
   }
   // Functions to manage works ends
}