<?php

/**
 * @Author: Nighil George
 * @Date:   2017-12-02 13:24:24
 * @Last Modified by:   Nighil George
 * @Last Modified time: 2018-03-06 12:22:50
 */
class Products extends MY_Model
{
	protected $_table_name = 'products';
    protected $_primary_key = 'id';
    // protected $_primary_filter = 'intval';
    // protected $_order_by = 'position';
    protected $_rules = array();
    // protected $_timestamps = TRUE;  
   function getAll()
   {
   	$query=$this->db->select('p.id,name,category,u.path,t.type')
   					->from('products p')
            ->join('categories c','c.id=p.categoryId')
            ->join('types t','t.id=p.typeId','LEFT')
   					->join('uploads u','u.id=p.imageId','LEFT')
            ->order_by(count('category'),'DESC')
   					->get()
   					->result();
   	if(!empty($query))
   		return $query;
   	else
   		return false;
   }
   function getAllForBenefitEdit()
   {
   	$query=$this->db->select('p.id,name,category,type,p.description')
   					->from('products p')
   					->join('categories c','c.id=p.categoryId')
   					->join('types t','t.id=p.typeId')
   					->get()
   					->result();
   	if(!empty($query))
   		return $query;
   	else
   		return false;
   }
   function getProductById($id){
   	$query=$this->db->select('id,name,categoryId,typeId,description')
   					->from('products')
   					->where('id',$id)
   					->get()
   					->row();
   	if(!empty($query))
   		return $query;
   	else
   		return false;
   }
   function getProductForUploads(){
    $query=$this->db->select('p.id,name as content,t.type')
            ->from('products p')
            ->join('types t','t.id=p.typeId')
            ->get()
            ->result();
    if(!empty($query))
      return $query;
    else
      return false;
   }
   
   function getproductBYcategory($id){
       $product=$this->db->select('p.id as productId,p.name as product_name,p.description as productdescriptn,t.description as typedescrptn,t.type,u.path,u.thumb_path,b.benefit,b.image,b.description,c.category,ul.path as producttypeimage,ul.thumb_path as producttypethumbimage')
               ->from('products p')
               ->join('types t','t.id=p.typeId')
               ->join('uploads ul','ul.id=t.image','left')
//               ->join('productimage pi','pi.productId=p.id')               
               ->join('uploads u','u.id=p.imageId')
               ->join('benefits b','b.productId=p.id','left')
               ->join('categories c','c.id=p.categoryId')
               ->where('p.categoryId',$id)
               ->where('u.status','active')
               ->get()->result_array();
       return $product;
   }
   
   function getbenefitByproduct($productId){
       $benefit=$this->db->select('b.*,u.path as benefitiamge,u.thumb_path as thumbimage')
               ->from('benefits b')
               ->join('uploads u','u.id=b.image','left')
               ->where('b.productId',$productId)
               ->get()->result();
       return $benefit;
       
       
       
   }
   function getProductwithimage($name=null,$type=null){
    if($name!=null){
       $this->db->select('p.id,p.name,p.description,p.direction,t.type,c.category,c.bgchangable,ucb.path as campusboardpdf,u.path as productimage,u.thumb_path as productthumb,ub.path as Backgroundimage,utds.path as tds,upack.path as packet');
      $this->db->from('products p');
      $this->db->join('categories c','c.id=p.categoryId');
      $this->db->join('uploads ucb','ucb.id=p.campusBoard','left');
      $this->db->join('uploads utds','utds.id=p.tds','left');
      $this->db->join('uploads upack','upack.id=p.packetImg','left');
      $this->db->join('uploads u','u.id=p.imageId');
      $this->db->join('types t','t.id=p.typeId','LEFT');
      $this->db->join('uploads ub','ub.id=p.bgImage','LEFT');
      $this->db->where('p.name',$name);
      if(!empty($type))
        $this->db->where('t.type',$type);
      $data=$this->db->get()->row();
       return $data;
     }else{
      return false;
     }
   }
    function getallProducts($limit=null){
      $this->db->select('p.id,u.path as productimage,u.thumb_path as productthumb');
      $this->db->from('products p');
      $this->db->join('uploads u','u.id=p.imageId');
      if($limit!=null){
        $this->db->limit($limit);
      }
      $data=$this->db->get()->result_array();
       return $data;
   }
   function getFeaturedproducts(){
       $feature=1;
       $featured=$this->db->select('p.*,u.path')
//               pi.id as imageId
               ->from('products p')
//               ->join('productimage pi','pi.productId=p.id')
               ->join('uploads u','u.id=p.openImage')
               ->where('featured',$feature)
               ->get()->result_array();
       return $featured;
   }
   function getFeaturedSlider(){
       $feature=1;
       $featured=$this->db->select('p.*,u.path,c.category,uopen.path as openImage,t.type')
               ->from('products p')
               ->join('categories c','c.id=p.categoryId')
               ->join('types t','t.id=p.typeId')
               ->join('uploads u','u.id=p.imageId')
               ->join('uploads uopen','uopen.id=p.openImage')
               ->where('featured',$feature)
               ->get()->result();
       return $featured;
   }
   function getpacketids($product){
    $query=$this->db->select('id')
                    ->from('packets')
                    ->where('productId',$product)
                    ->get()
                    ->result();
    if(!empty($query))
        return $query;
      else
        return false;
   }
   function getpacketsOfProduct($product=null,$name=null,$type=null){
    $this->db->select('ps.packetSize');
    $this->db->from('packets ps');
    $this->db->join('products p','p.id=ps.productId');
    $this->db->join('types t','t.id=p.typeId','LEFT');
    if($product!=null)
      $this->db->where('ps.productId',$product);
    elseif($name!=null)
      $this->db->where('p.name',$name);
    if($type!=null)
      $this->db->where('t.type',$type);
    $query=$this->db->get()->result();
    if(!empty($query))
        return $query;
      else
        return false;
   }
   function getProductFinishes($id=null,$name=null,$type=null){
    $this->db->select('f.id,f.productId,p.name,f.finish');
    $this->db->from('finishes f');
    $this->db->join('products p','p.id=f.productId');
    if($id!=null){
      $this->db->where('f.productId',$id);
    }elseif($name!=null){
        $this->db->where('p.name',$name);
    }
    $query=$this->db->get()->result_array();
    if(!empty($query))
      return $query;
    else
      return false;
   }

   function getFinishIds($product){
      $query=$this->db->select('id')
            ->from('finishes')
            ->where('productId',$product)
            ->get()
            ->result();
    if(!empty($query))
      return $query;
    else
      return false;
   }
}