<?php

/*
 * Copyright (C) Hawks Solutions  - All Rights Reserved 
 * 
 * Unauthorized copying of this file, via any medium is strictly prohibited 
 * 
 * Proprietary and confidential 
 * 
 * Written by Anuraj <anurajpr2266@gmail.com>, September 2017  
 */

/*
 * Upload Model 
 */

class Upload extends MY_Model {
    
    protected $_table_name = 'uploads';
    protected $_primary_key = 'id';
    protected $_primary_filter = 'intval';
    protected $_order_by = 'id';
    protected $_rules = array();
    protected $_timestamps = false;      
    
    /*
     * function insertOrUpdateUploadData()
     * 
     * @param array
     * 
     * @return boolean
     */

    function insertOrUpdateUploadData($data = null) {
        if (!empty($data)) {
            $insert = array(
                'path' => $data['upload_data']['path'],
                'contentTypeId' => 0,
                'contentId' => 0,
                'file_type' => $data['upload_data']['file_type'],
                'image_type' => $data['upload_data']['image_type'],
                'image_size_str' => $data['upload_data']['image_size_str'],
                'file_ext' => $data['upload_data']['file_ext'],
                'file_name' => $data['upload_data']['file_name'],
                'image_width' => $data['upload_data']['image_width'],
                'image_height' => $data['upload_data']['image_height'],
                'original_name' => $data['upload_data']['orig_name'],
                'file_size' => $data['upload_data']['file_size'],
                'thumb_path' => $data['upload_data']['thumb_path']
            );
            $this->db->insert('uploads', $insert);
            return true;
        }
        return false;
    }
     /*
     * Function getAllImages
     * 
     * @param null
     * 
     * @return json
     */

    function getAllImages(){
       $query = $this->db->query('SELECT * FROM uploads ORDER BY id DESC');
       if(!empty($query))
            return $query->result_array();
        else
            return json_encode(array());
    }
    /*
     * Function getImagesByDate
     * 
     * @param string date
     * 
     * @return json
     */

    function getImagesByDate($currentDate = null) {
        if (!empty($currentDate)) {
            $query = $this->db->query('SELECT * FROM uploads WHERE DATE(`created_date`)="' . $currentDate . '" ORDER BY id DESC');
            return json_encode($query->result_array());
        }
        return json_encode(array());
    }

    /*
     * Function getAllImageTypes
     * 
     * @param null
     * 
     * @return json
     */

    function getAllImageTypes() {
        if (!empty($currentDate)) {
            $query = $this->db->query('SELECT id,image_type,`width`,`height` FROM image_types');
            return json_encode($query->result_array());
        }
        return json_encode(array());
    }
    
    /*fn to get information of a particular image.
     * param is image-id.
     */
    function getImageById($imgId){
        if (!empty($imgId)) {
            $query = $this->db->query('SELECT * FROM uploads WHERE id ="' . $imgId . '" ');
            return json_encode($query->result_array());
        }
        return json_encode(array());
    }
    
    /*
     * fn to get image by type.
     */
    function getImagebyType($typeId){
        if (!empty($typeId)) {
            $query = $this->db->query('SELECT * FROM uploads WHERE contentTypeId ="' . $typeId . '" ');
            return $query->result_array();
        }
        return null;
    }

}
