/* 
 * Copyright (C) Hawks Solutions  - All Rights Reserved 
 * 
 * Unauthorized copying of this file, via any medium is strictly prohibited 
 * 
 * Proprietary and confidential 
 * 
 * Written by Anuraj <anurajpr2266@gmail.com>, September 2017  
 */

/*
 * LoginController 
 */

adminApp.controller('contentTypeController', function ($scope, $http, $timeout, $q) {

//    var temp_dashboard = angular.element('#data-dashboard').val();
//    var data_dashboard = JSON.parse(temp_dashboard);

    angular.extend($scope, {
//        dashboarddata: data_dashboard,  
        contentTypes: {},

        savecontenttype: function () {
            if ($scope.contentType == "") {
                toastMessage('Please specify the content type !!');
            } else if ($('#haveimage').prop('checked') == false && $('#havecontent').prop('checked') == false) {
                toastMessage('The content type is not specified !!');
            } else {
                var form = angular.element('#formcontenttype');
                var data_save = form.serialize();
                showLoader();
                $timeout(function () {
                    $http({
                        method: 'POST',
                        url: baseUrl + 'admin/Dashboard/ajax',
                        data: data_save + '&action=savecontenttype',
                        headers: {
                            'Content-Type': 'application/x-www-form-urlencoded',
                            'X-Requested-With': 'XMLHttpRequest'
                        }
                    }).then(function successCallback(response) {
                        if (response.data.success == true) {
                            toastSuceess("content type added succesfully");
                            $scope.clearForm();
                        } else {
                            toastError('internal error occured');
                        }

                    });
                    hideLoader();
                }, 1000);
            }
        },

        /* 
         * fn to clear $ refreash form.
         */
        clearForm: function () {
            $scope.contentType = "";
            $scope.width = "";
            $scope.height = "";
            $('#haveimage').prop('checked', false);
            $('#havecontent').prop('checked', false);
            $('#multipleimage').prop('checked', false);
            $('#multilecontent').prop('checked', false);
            $scope.haveimage = false;
            $scope.havecontent = false;
            $http({
                method: 'POST',
                url: baseUrl + 'admin/Dashboard/ajax',
                data: '&action=getContentTypes',
                headers: {
                    'Content-Type': 'application/x-www-form-urlencoded',
                    'X-Requested-With': 'XMLHttpRequest'
                }
            }).then(function successCallback(response) {
                if (response.data.success == true) {
                    $scope.contentTypes = response.data.contentTypes;
                } else {
                    toastError('internal error occured');
                }

            });
        },

        /*
         * fn to show confirmation message for deletion.
         */
        confirmationMsg: function (typeId) {
            alertify.confirm('Delete', 'Do you want to delete this item', function () {
                $scope.deleteContentType(typeId);
            }
            , function () {
            });
        },

        /*
         * fn to delete content type.
         */
        deleteContentType: function (typeId) {
            if (!angular.isUndefined(typeId)) {
                showLoader();
                $timeout(function () {
                    $http({
                        method: 'POST',
                        url: baseUrl + 'admin/Dashboard/ajax',
                        data: 'action=deleteContenttype&typeId=' + typeId,
                        headers: {
                            'Content-Type': 'application/x-www-form-urlencoded',
                            'X-Requested-With': 'XMLHttpRequest'
                        }
                    }).then(function successCallback(response) {
                        if (response.data.success == true) {
                            toastSuceess("Content type removed successfully");
                            $scope.clearForm();
                        } else {
                            toastError("Error !!");
                        }
                    });
                    hideLoader();
                }, 1000);
            }
        }

    });
});

$(document).ready(function (e) {
    var quill = new Quill('#editor', {
        theme: 'snow'
    });
});
