<?php

/**
 * Hawks Solutions 
 * All right are reserved under copyright law.for further queries <hawkssolution@gmail.com>
 * Description of CommonAction
 *
 * @author Anuraj <anurajpr2266@gmail.com> ,CommonAction
 */

namespace App\Action;

use Slim\Views\Twig;
use Psr\Log\LoggerInterface;
use Slim\Http\Request;
use Slim\Http\Response;
use App\Model\Common;
use App\Model\Logins;
use App\Model\Registration;
use App\Model\Booking;
// use App\Model\Meditation;

final class CommonAction {

    private $view;
    private $logger;
    private $mailer;

    public function __construct(Twig $view, LoggerInterface $logger, \Swift_Mailer $mailer) {
        $this->view = $view;
        $this->logger = $logger;
        $this->mailer = $mailer;
    }

    /*
     * simple pagination
     * a common fn that can be used by non-joining tables
     */

    public function simplepaginate(Request $request, Response $response, $args) {
        $data = $request->getParsedBody();
        $commonObj = new Common();
        $total = count($commonObj->entireData($data['table']));
        $pageData = $commonObj->pageData($data['table'], $data['offset'], $data['pageLimit']);
        $lastPage = ceil($total / $data['pageLimit']);
        $pagination = array(
            'currentPage' => $data['offset'] + 1,
            'pageData' => $pageData,
            'total' => $total,
            'lastPage' => $lastPage
        );
        return $response->withStatus(200)->getBody()->write(Json_encode(array('pagination' => $pagination)));
    }
    /*
     * Send Mail
     * a common fn that can be used to send mail
     */

    public function sendMail(Request $request, Response $response, $args) {
        $data = $request->getParsedBody();
        $commonObj = new Common();
        $apistatus = $commonObj->sendMail($mailer,$data['type'],$data['mail'],$data['field'],$data['id']);
        if($apistatus)
            $status=true;
        else
            $status=false;
        return $response->withStatus(200)->getBody()->write(Json_encode(array('status' => $status,'data'=>$data)));
    }
    /*
     * getDailyaudio
     * a common fn that can be used to send mail
     */

    public function getDailyaudio(Request $request, Response $response, $args) {
        $data = $request->getParsedBody();
        $today=$data['date'];
        $commonObj = new Common();
        $audio = $commonObj->getDailyaudio($today);
        return $response->withStatus(200)->getBody()->write(Json_encode(array('data'=>$audio)));
    }
    /*
     * getQuote
     * a common fn that can be used to send mail
     */

    public function getQuote(Request $request, Response $response, $args) {
        $data = $request->getParsedBody();
        $commonObj = new Common();
        $audio = $commonObj->getQuote();
        return $response->withStatus(200)->getBody()->write(Json_encode(array('data'=>$audio)));
    }
    /*
     * togglestatus
     * a common fn that can be used by non-joining tables
     */

    public function togglestatus(Request $request, Response $response, $args) {
        $data = $request->getParsedBody();
        $commonObj = new Common();
        $apistatus = $commonObj->togglestatus($data['table'],$data['status'],$data['id']);
        if($apistatus)
            $status=true;
        else
            $status=false;
        return $response->withStatus(200)->getBody()->write(Json_encode(array('status' => $status,'data'=>$status)));
    }
    /*
     * togglemultistatus
     * a common fn that can be used by non-joining tables
     */

    public function togglestatusMulti(Request $request, Response $response, $args) {
        $data = $request->getParsedBody();
        $commonObj = new Common();
        $apistatus = $commonObj->togglestatusMulti($data['table'],$data['status'],$data['ids']);
        if($apistatus)
            $status=true;
        else
            $status=false;
        return $response->withStatus(200)->getBody()->write(Json_encode(array('status' => $status)));
    }
    /*
     * deleteimage
     * a common fn that can be used by non-joining tables
     */

    public function deleteimage(Request $request, Response $response, $args) {
        $data = $request->getParsedBody();
        $commonObj = new Common();
        $apistatus = $commonObj->deleteimage($data['table'],$data['id']);
        if($apistatus)
            $status=true;
        else
            $status=false;
        return $response->withStatus(200)->getBody()->write(Json_encode(array('status' => $status)));
    }
    /*
     * softdelete
     * a common fn that can be used by non-joining tables
     */

    public function softdelete(Request $request, Response $response, $args) {
        $data = $request->getParsedBody();
        $commonObj = new Common();
        $apistatus = $commonObj->softdelete($data['table'],$data['id']);
        if($apistatus)
            $status=true;
        else
            $status=false;
        return $response->withStatus(200)->getBody()->write(Json_encode(array('status' => $status)));
    }
    /*
     * softdelete Multiple items
     * a common fn that can be used by non-joining tables
     */

    public function softdeleteMulti(Request $request, Response $response, $args) {
        $data = $request->getParsedBody();
        $commonObj = new Common();
        $apistatus = $commonObj->softdeleteMulti($data['table'],$data['ids']);
        if($apistatus)
            $status=true;
        else
            $status=false;
        return $response->withStatus(200)->getBody()->write(Json_encode(array('status' => $status)));
    }
    /*
     * getrow
     * a common fn that can be used by non-joining tables
     */

    public function getrow(Request $request, Response $response, $args) {
        $data = $request->getParsedBody();
        $commonObj = new Common();
        $result = $commonObj->getrow($data['table'],$data['field'],$data['id']);
        if($result)
            return $response->withStatus(200)->getBody()->write(Json_encode(array('status' =>true,"result"=> $result)));
        else
                return $response->withStatus(200)->getBody()->write(Json_encode(array('status' =>false)));
    }

    /*
     * fn for pagination
     * come to use when there is a single condition to be satisfied whren selecting datas from a single table
     */

    public function singleConditionPagination(Request $request, Response $response, $args) {
        $data = $request->getParsedBody();
        $commonObj = new Common();
        $total = count($commonObj->entireDatawithCondition($data['table'],  $data['key'], $data['value']));
        $pageData = $commonObj->pageDatawithCondition($data['table'], $data['prePage'], $data['perPage'], $data['key'], $data['value']);
        $lastPage = ceil($total / $data['perPage']);
        $pagination = array(
            'currentPage' => $data['prePage'] + 1,
            'pageData' => $pageData,
            'total' => $total,
            'lastPage' => $lastPage
        );
        return $response->withStatus(200)->getBody()->write(Json_encode(array('pagination' => $pagination)));
    }

    /*
     * fn to search an item in a table
     */

    public function searchItem(Request $request, Response $response, $args) {
        $data = $request->getParsedBody();
        $commonObj = new Common();
        // $connector=$data['connector'];
        $fields=$data['field'];
        $operator=$data['operator'];
        $value=$data['searchvalue'];
        $conditions=[];
        for ($i=0;$i<count($fields);$i++) {
            if($operator=='like'){
                $condition=array($fields[$i],$operator,'%'.$value.'%');
            }else{
                $condition=array($fields[$i],$operator,$value);
            }
                array_push($conditions, $condition);
            }        

        $total = count($commonObj->entireDatawithCondition($data['table'],$conditions));
        $pageData = $commonObj->pageDatawithCondition($data['table'], $data['offset'], $data['pageLimit'],$conditions);
        $lastPage = ceil($total / $data['pageLimit']);
        $pagination = array(
            'currentPage' => $data['offset'] + 1,
            'pageData' => $pageData,
            'total' => $total,
            'lastPage' => $lastPage
        );
        return $response->withStatus(200)->getBody()->write(Json_encode(array('pagination' => $pagination)));
    }

    /*
     * Function authenticate User
     * 
     * @param $request ,$response
     * 
     * $retun json
     */

    public function authenticateUser(Request $request, Response $response, $args) {
        // $this->logger->info("Login validity check trigered");
        $data = $request->getParsedBody();
        $commonObj = new Common();
        $response->getBody()->write($commonObj->authenticateUser($data));
        return $response;
    }
    
    /*
    *fn to get password
    */
    public function getPassword(Request $request, Response $response, $args){
        $data =$request->getParsedBody(); 
        $auth=new Logins();
        $password=$auth->getPassword($data['loginId']);
        if($password){
            $result=array(
                'success'=>true,
                'password'=>$password,
            );
        }else{
            $result=array(
                'success'=>false
            );
        }
        return $response->withStatus(200)->getBody()->write(Json_encode($result));
    }
    
    /*
    *fn to change password
    */
    public function changePassword(Request $request, Response $response, $args){
        $data =$request->getParsedBody(); 
        $auth=Logins::find($data['loginId']);
        $auth->username=$auth->username;
        $auth->password=$data['encrypted'];
        $auth->usertype=$auth->usertype;
        $auth->memberId=$auth->memberId;
        if($auth->save()){
           $status=array(
                'success'=>true, 
           ); 
        }else{
            $status=array(
                'success'=>false, 
           );
        }
        return $response->withStatus(200)->getBody()->write(Json_encode($status));
    }

}
